<template>
  <PageContainer :title="'MY MODEL PHOTO'">
    <StackLayout width="100%" padding="0,10">
      <FlexboxLayout
        marginBottom="10"
        height="auto"
        width="100%"
        flexDirection="column"
        alignItems="center"
      >
        <Label text="This is a great photo!" fontSize="12" />
      </FlexboxLayout>

      <FlexboxLayout marginBottom="20" flexDirection="column">
        <InputText ref="title" label="title" :required="true" v-model="title" />
      </FlexboxLayout>

      <Image :src="imageUrl || ''" width="100%" marginBottom="0" />

      <FlexboxLayout
        marginBottom="200"
        height="auto"
        width="100%"
        flexDirection="column"
        alignItems="center"
      >
        <StackLayout height="auto" width="auto" horizontalAlignment="center">
          <RoundButton :width="150" :pink="true" text="SAVE" @onTap="onSave" />
        </StackLayout>
      </FlexboxLayout>
    </StackLayout>
  </PageContainer>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from "vuex";
import { GETTERS as APP_GETTERS } from "~/store";
import { ACTIONS, GETTERS, MUTATORS } from "~/store/member";
import { GETTERS as MENU_GETTERS } from "~/store/menu";
import {
  getMemberModelPhotoDetail,
  saveMemberModelPhoto,
  getOptionStates
} from "~/services";
import RoundButton from "~/components/Button/RoundButton";
import InputText from "~/components/Input/InputText";
import InputSelect from "~/components/Input/InputSelect";
import PageContainer from "../PageContainer";
export default {
  props: ["modelPhotoId"],
  components: {
    PageContainer,
    RoundButton,
    InputText,
    InputSelect
  },
  data() {
    return {
      // modelPhotoDetail: {
      //   Title: "",
      //   PhotoURLCover: ""
      // }
      title: "",
      imageUrl: ""
    };
  },
  watch: {
    modelPhotoItem() {
      if (this.modelPhotoItem !== null) {
        console.log("PHOTO URL: ", this.modelPhotoItem.PhotoURLCover);
        this.title = this.modelPhotoItem.Title;
        this.imageUrl = this.modelPhotoItem.PhotoURLCover;
      }
    }
  },
  computed: {
    ...mapGetters({
      isLoading: APP_GETTERS.PROCESSING,
      memberId: GETTERS.MEMBER_ID,
      modelPhotoList: GETTERS.MODELPHOTOS,
      modelPhotoItem: GETTERS.MODELPHOTO_DETAIL
    })
  },
  methods: {
    ...mapActions({
      loadModelPhotoList: ACTIONS.LOAD_MODELPHOTOS,
      loadModelPhotoDetail: ACTIONS.LOAD_MODELPHOTO_DETAIL
    }),
    ...mapMutations({
      updateModelPhotoChangeStack: MUTATORS.MODELPHOTO_CHANGED
    }),
    // async loadModelPhotoDetail() {
    //   console.log(this.memberId, this.modelPhotoId);

    //   try {
    //     const rawData = await getMemberModelPhotoDetail(this.memberId, this.modelPhotoId);
    //     let response = null
    //     if (Array.isArray(rawData)) {
    //       response = rawData[0]
    //     } else {
    //       response = rawData
    //     }

    //     console.log("DATA MODEL PHOTO DETAIL: ", response.Title, response.PhotoURLCover);

    //     this.modelPhotoDetail.Title = response.Title;
    //     this.modelPhotoDetail.PhotoURLCover = response.PhotoURLCover;
    //   } catch (error) {
    //     console.log(error);
    //   }
    // },
    validateAll() {
      const validTitle = this.$refs.title.valid();
      return validTitle;
    },
    async onSave() {
      if (this.validateAll()) {
        try {
          const requestData = {
            ...this.modelPhotoDetail,
            MemberModelPhotoID: this.modelPhotoId
          };
          console.log(JSON.stringify(requestData));
          const response = await saveMemberModelPhoto(
            this.memberId,
            requestData
          );
          console.log("response", response);
          if (response) {
            if (response.Message) {
              this.onRequestFail(response.Message);
            } else {
              this.onRequestSuccess(response.Status);
            }
          } else {
            this.onRequestFail();
          }
        } catch (error) {
          this.onRequestFail(error.message);
        }
      } else {
        this.$showAlert("Some provided info are invalid. Please check!");
      }
    },
    onRequestFail(msg = "") {
      this.$showConfirm({
        message: msg || "Something went wrong, please try again later!"
      }).then(result => {
        if (result) {
          console.log("response to err: ", result);
        }
      });
    },
    onRequestSuccess(msg = "") {
      this.$showAlert(msg || "Your model photo is saved.", 2).then(() => {
        this.loadModelPhotoList(this.memberId);
        this.updateModelPhotoChangeStack();
        this.$navigateBack();
      });
    }
  },
  mounted() {
    if (this.modelPhotoId) {
      console.log("CALL API DETAIL", this.modelPhotoId);
      const param = {
        memberId: this.memberId,
        modelPhotoId: this.modelPhotoId
      };
      this.loadModelPhotoDetail(param);
    }
  }
};
</script>

<style scoped>
</style>
